Clazz.declarePackage ("jalview.analysis");
Clazz.load (null, "jalview.analysis.ParseProperties", ["jalview.datamodel.AlignmentAnnotation", "jalview.jsdev.RegExp", "java.lang.Double"], function () {
c$ = Clazz.decorateAsClass (function () {
this.al = null;
Clazz.instantialize (this, arguments);
}, jalview.analysis, "ParseProperties");
Clazz.makeConstructor (c$, 
function (al) {
this.al = al;
}, "jalview.datamodel.AlignmentI");
Clazz.defineMethod (c$, "getScoresFromDescription", 
function (ScoreName, ScoreDescriptions, regex, repeat) {
return this.getScoresFromDescription ( Clazz.newArray (-1, [ScoreName]),  Clazz.newArray (-1, [ScoreDescriptions]), regex, repeat);
}, "~S,~S,~S,~B");
Clazz.defineMethod (c$, "getScoresFromDescription", 
function (ScoreNames, ScoreDescriptions, regex, repeat) {
return this.getScoresFromDescription (this.al.getSequencesArray (), ScoreNames, ScoreDescriptions, regex, repeat);
}, "~A,~A,~S,~B");
Clazz.defineMethod (c$, "getScoresFromDescription", 
function (seqs, ScoreNames, ScoreDescriptions, regex, repeat) {
var count = 0;
var pattern = jalview.jsdev.RegExp.newRegex ([regex]);
if (pattern.numSubs () > ScoreNames.length) {
var onamelen = ScoreNames.length;
var tnames =  new Array (pattern.numSubs () + 1);
System.arraycopy (ScoreNames, 0, tnames, 0, ScoreNames.length);
var base = tnames[ScoreNames.length - 1];
ScoreNames = tnames;
var descrbase = ScoreDescriptions[onamelen - 1];
if (descrbase == null) {
descrbase = "Score parsed from (" + regex + ")";
}tnames =  new Array (pattern.numSubs () + 1);
System.arraycopy (ScoreDescriptions, 0, tnames, 0, ScoreDescriptions.length);
ScoreDescriptions = tnames;
for (var i = onamelen; i < ScoreNames.length; i++) {
ScoreNames[i] = base + "_" + i;
ScoreDescriptions[i] = descrbase + " (column " + i + ")";
}
}for (var i = 0; i < seqs.length; i++) {
var descr = seqs[i].getDescription ();
if (descr == null) {
continue;
}var pos = 0;
var added = false;
var reps = 0;
while ((repeat || pos == 0) && pattern.searchFrom (descr, pos)) {
pos = pattern.matchedTo ();
for (var cols = 0; cols < pattern.numSubs (); cols++) {
var sstring = pattern.stringMatchedI (cols + 1);
var score = NaN;
try {
score =  new Double (sstring).doubleValue ();
} catch (e) {
if (Clazz.exceptionOf (e, Exception)) {
continue;
} else {
throw e;
}
}
var an =  new jalview.datamodel.AlignmentAnnotation (ScoreNames[cols] + ((reps > 0) ? "_" + reps : ""), ScoreDescriptions[cols], null);
an.setScore (score);
System.out.println (seqs[i].getName () + " score: '" + ScoreNames[cols] + "' = " + score);
an.setSequenceRef (seqs[i]);
seqs[i].addAlignmentAnnotation (an);
this.al.addAnnotation (an);
added = true;
}
reps++;
}
if (added) {
count++;
}}
return count;
}, "~A,~A,~A,~S,~B");
});
