Clazz.declarePackage ("jalview.commands");
Clazz.load (["jalview.commands.CommandI"], "jalview.commands.ChangeCaseCommand", ["java.lang.StringBuffer"], function () {
c$ = Clazz.decorateAsClass (function () {
this.description = null;
this.caseChange = -1;
this.seqs = null;
this.regions = null;
Clazz.instantialize (this, arguments);
}, jalview.commands, "ChangeCaseCommand", null, jalview.commands.CommandI);
Clazz.makeConstructor (c$, 
function (description, seqs, regions, caseChange) {
this.description = description;
this.seqs = seqs;
this.regions = regions;
this.caseChange = caseChange;
this.doCommand (null);
}, "~S,~A,java.util.List,~N");
Clazz.overrideMethod (c$, "getDescription", 
function () {
return this.description;
});
Clazz.overrideMethod (c$, "getSize", 
function () {
return 1;
});
Clazz.overrideMethod (c$, "doCommand", 
function (views) {
this.changeCase (true);
}, "~A");
Clazz.overrideMethod (c$, "undoCommand", 
function (views) {
this.changeCase (false);
}, "~A");
Clazz.defineMethod (c$, "changeCase", 
function (doCommand) {
var sequence;
var start;
var end;
var nextChar;
for (var r, $r = this.regions.iterator (); $r.hasNext () && ((r = $r.next ()) || true);) {
start = r[0];
for (var s = 0; s < this.seqs.length; s++) {
sequence = this.seqs[s].getSequenceAsString ();
var newSeq =  new StringBuffer ();
if (r[1] > sequence.length) {
end = sequence.length;
} else {
end = r[1];
}if (start > 0) {
newSeq.append (sequence.substring (0, start));
}if ((this.caseChange == jalview.commands.ChangeCaseCommand.TO_UPPER && doCommand) || (this.caseChange == jalview.commands.ChangeCaseCommand.TO_LOWER && !doCommand)) {
newSeq.append (sequence.substring (start, end).toUpperCase ());
} else if ((this.caseChange == jalview.commands.ChangeCaseCommand.TO_LOWER && doCommand) || (this.caseChange == jalview.commands.ChangeCaseCommand.TO_UPPER && !doCommand)) {
newSeq.append (sequence.substring (start, end).toLowerCase ());
} else {
for (var c = start; c < end; c++) {
nextChar = sequence.charAt (c);
if ('a' <= nextChar && nextChar <= 'z') {
nextChar = String.fromCharCode (nextChar.charCodeAt (0) - (32));
} else if ('A' <= nextChar && nextChar <= 'Z') {
nextChar = String.fromCharCode (nextChar.charCodeAt (0) + (32));
}newSeq.append (nextChar);
}
}if (end < sequence.length) {
newSeq.append (sequence.substring (end));
}this.seqs[s].setSequence (newSeq.toString ());
}
}
}, "~B");
Clazz.defineStatics (c$,
"TO_LOWER", 0,
"TO_UPPER", 1,
"TOGGLE_CASE", 2);
});
