Clazz.declarePackage ("jalview.util");
Clazz.load (["java.text.MessageFormat", "java.util.logging.Logger"], "jalview.util.MessageManager", ["java.util.Locale", "$.ResourceBundle", "java.util.logging.Level"], function () {
c$ = Clazz.declareType (jalview.util, "MessageManager");
c$.getString = Clazz.defineMethod (c$, "getString", 
function (key) {
var value = "[missing key] " + key;
try {
value = jalview.util.MessageManager.rb.getString (key);
} catch (e) {
if (Clazz.exceptionOf (e, Exception)) {
jalview.util.MessageManager.log.warning ("I18N missing: " + jalview.util.MessageManager.loc + "\t" + key);
} else {
throw e;
}
}
return value;
}, "~S");
c$.getLocale = Clazz.defineMethod (c$, "getLocale", 
function () {
return jalview.util.MessageManager.loc;
});
c$.formatMessage = Clazz.defineMethod (c$, "formatMessage", 
function (key, params) {
return java.text.MessageFormat.format (jalview.util.MessageManager.getString (key), params);
}, "~S,~A");
c$.formatMessage = Clazz.defineMethod (c$, "formatMessage", 
function (key, params) {
return java.text.MessageFormat.format (jalview.util.MessageManager.getString (key), params);
}, "~S,~A");
c$.getStringOrReturn = Clazz.defineMethod (c$, "getStringOrReturn", 
function (keyroot, name) {
var smkey = keyroot + name.toLowerCase ().replaceAll (" ", "");
try {
name = jalview.util.MessageManager.rb.getString (smkey);
} catch (x) {
if (Clazz.exceptionOf (x, Exception)) {
jalview.util.MessageManager.log.finest ("I18N missing key with root " + keyroot + ": " + jalview.util.MessageManager.loc + "\t" + smkey);
} else {
throw x;
}
}
return name;
}, "~S,~S");
Clazz.defineStatics (c$,
"rb", null);
c$.log = c$.prototype.log = java.util.logging.Logger.getLogger (jalview.util.MessageManager.getCanonicalName ());
Clazz.defineStatics (c$,
"loc", null);
{
try {
jalview.util.MessageManager.loc = java.util.Locale.getDefault ();
jalview.util.MessageManager.log.info ("Getting messages for lang: " + jalview.util.MessageManager.loc);
jalview.util.MessageManager.rb = java.util.ResourceBundle.getBundle ("lang.Messages", jalview.util.MessageManager.loc);
if (jalview.util.MessageManager.rb == null || jalview.util.MessageManager.log.isLoggable (java.util.logging.Level.FINEST)) {
jalview.util.MessageManager.log.finest ("Language keys: " + jalview.util.MessageManager.rb.keySet ());
}} catch (e$$) {
if (Clazz.exceptionOf (e$$, Exception)) {
var q = e$$;
{
jalview.util.MessageManager.log.warning ("Exception when initting Locale for i18n messages\n" + q.getMessage ());
q.printStackTrace ();
}
} else if (Clazz.exceptionOf (e$$, Error)) {
var v = e$$;
{
jalview.util.MessageManager.log.warning ("Error when initting Locale for i18n messages\n" + v.getMessage ());
v.printStackTrace ();
}
} else {
throw e$$;
}
}
}});
