Clazz.declarePackage ("jalview.analysis");
Clazz.load (["java.util.Arrays", "$.HashSet", "$.Hashtable"], "jalview.analysis.Rna", ["jalview.analysis.SecStrConsensus", "$.WUSSParseException", "jalview.datamodel.SequenceFeature", "jalview.util.MessageManager", "java.lang.StringBuffer", "java.util.ArrayList", "$.Stack", "$.Vector"], function () {
c$ = Clazz.declareType (jalview.analysis, "Rna");
c$.isOpeningParenthesis = Clazz.defineMethod (c$, "isOpeningParenthesis", 
($fz = function (c) {
return jalview.analysis.Rna.openingParsSet.contains (new Character (c).charCodeAt (0));
}, $fz.isPrivate = true, $fz), "~S");
c$.isClosingParenthesis = Clazz.defineMethod (c$, "isClosingParenthesis", 
($fz = function (c) {
return jalview.analysis.Rna.closingParsSet.contains (new Character (c).charCodeAt (0));
}, $fz.isPrivate = true, $fz), "~S");
c$.matchingOpeningParenthesis = Clazz.defineMethod (c$, "matchingOpeningParenthesis", 
($fz = function (closingParenthesis) {
if (!jalview.analysis.Rna.isClosingParenthesis (closingParenthesis)) {
throw  new jalview.analysis.WUSSParseException (jalview.util.MessageManager.formatMessage ("exception.querying_matching_opening_parenthesis_for_non_closing_parenthesis",  Clazz.newArray (-1, [ new StringBuffer (closingParenthesis.charCodeAt (0)).toString ()])), -1);
}return String.fromCharCode (jalview.analysis.Rna.closingToOpening.get (new Character (closingParenthesis).charCodeAt (0)));
}, $fz.isPrivate = true, $fz), "~S");
c$.GetSimpleBPs = Clazz.defineMethod (c$, "GetSimpleBPs", 
function (line) {
var stacks =  new java.util.Hashtable ();
var pairs =  new java.util.Vector ();
var i = 0;
while (i < line.length) {
var base = line.charAt (i);
if (jalview.analysis.Rna.isOpeningParenthesis (base)) {
if (!stacks.containsKey (new Character (base).charCodeAt (0))) {
stacks.put (new Character (base).charCodeAt (0),  new java.util.Stack ());
}stacks.get (new Character (base).charCodeAt (0)).push (new Integer (i));
} else if (jalview.analysis.Rna.isClosingParenthesis (base)) {
var opening = jalview.analysis.Rna.matchingOpeningParenthesis (base);
if (!stacks.containsKey (new Character (opening).charCodeAt (0))) {
throw  new jalview.analysis.WUSSParseException (jalview.util.MessageManager.formatMessage ("exception.mismatched_unseen_closing_char",  Clazz.newArray (-1, [ new StringBuffer (base.charCodeAt (0)).toString ()])), i);
}var stack = stacks.get (new Character (opening).charCodeAt (0));
if (stack.isEmpty ()) {
throw  new jalview.analysis.WUSSParseException (jalview.util.MessageManager.formatMessage ("exception.mismatched_closing_char",  Clazz.newArray (-1, [ new StringBuffer (base.charCodeAt (0)).toString ()])), i);
}var temp = (stack.pop ()).intValue ();
pairs.add ( new jalview.analysis.SecStrConsensus.SimpleBP (temp, i));
}i++;
}
for (var opening, $opening = stacks.keySet ().iterator (); $opening.hasNext () && ((opening = $opening.next ()) || true);) {
var stack = stacks.get (new Character (opening).charCodeAt (0));
if (!stack.empty ()) {
throw  new jalview.analysis.WUSSParseException (jalview.util.MessageManager.formatMessage ("exception.mismatched_opening_char",  Clazz.newArray (-1, [ new StringBuffer (opening.charCodeAt (0)).toString (), Integer.$valueOf ((stack.pop ()).intValue ()).toString ()])), i);
}}
return pairs;
}, "CharSequence");
c$.GetBasePairs = Clazz.defineMethod (c$, "GetBasePairs", 
function (line) {
var bps = jalview.analysis.Rna.GetSimpleBPs (line);
var outPairs =  new Array (bps.size ());
for (var p = 0; p < bps.size (); p++) {
var bp = bps.elementAt (p);
outPairs[p] =  new jalview.datamodel.SequenceFeature ("RNA helix", "", "", bp.getBP5 (), bp.getBP3 (), "");
}
return outPairs;
}, "CharSequence");
c$.GetModeleBP = Clazz.defineMethod (c$, "GetModeleBP", 
function (line) {
var bps = jalview.analysis.Rna.GetSimpleBPs (line);
return  new java.util.ArrayList (bps);
}, "CharSequence");
c$.HelixMap = Clazz.defineMethod (c$, "HelixMap", 
function (pairs) {
var helix = 0;
var lastopen = 0;
var lastclose = 9999999;
var i = pairs.length;
var open;
var close;
var j;
var helices =  new java.util.Hashtable ();
for (i = 0; i < pairs.length; i++) {
open = pairs[i].getBegin ();
close = pairs[i].getEnd ();
if (open > lastclose) {
helix++;
}j = pairs.length - 1;
while (j >= 0) {
var popen = pairs[j].getBegin ();
if ((popen < lastopen) && (popen > open)) {
if (helices.containsValue (new Integer (popen)) && (((helices.get (new Integer (popen)))).intValue () === helix)) {
continue;
} else {
helix++;
break;
}}j -= 1;
}
helices.put (new Integer (open), new Integer (helix));
helices.put (new Integer (close), new Integer (helix));
pairs[i].setFeatureGroup (Integer.toString (helix));
lastopen = open;
lastclose = close;
}
}, "~A");
c$.pairHash = c$.prototype.pairHash =  new java.util.Hashtable ();
Clazz.defineStatics (c$,
"openingPars",  Clazz.newArray (-1, [new Character ('('), new Character ('['), new Character ('{'), new Character ('<'), new Character ('A'), new Character ('B'), new Character ('C'), new Character ('D'), new Character ('E'), new Character ('F'), new Character ('G'), new Character ('H'), new Character ('I'), new Character ('J'), new Character ('K'), new Character ('L'), new Character ('M'), new Character ('N'), new Character ('O'), new Character ('P'), new Character ('Q'), new Character ('R'), new Character ('S'), new Character ('T'), new Character ('U'), new Character ('V'), new Character ('W'), new Character ('X'), new Character ('Y'), new Character ('Z')]),
"closingPars",  Clazz.newArray (-1, [new Character (')'), new Character (']'), new Character ('}'), new Character ('>'), new Character ('a'), new Character ('b'), new Character ('c'), new Character ('d'), new Character ('e'), new Character ('f'), new Character ('g'), new Character ('h'), new Character ('i'), new Character ('j'), new Character ('k'), new Character ('l'), new Character ('m'), new Character ('n'), new Character ('o'), new Character ('p'), new Character ('q'), new Character ('r'), new Character ('s'), new Character ('t'), new Character ('u'), new Character ('v'), new Character ('w'), new Character ('x'), new Character ('y'), new Character ('z')]));
c$.openingParsSet = c$.prototype.openingParsSet =  new java.util.HashSet (java.util.Arrays.asList (jalview.analysis.Rna.openingPars));
c$.closingParsSet = c$.prototype.closingParsSet =  new java.util.HashSet (java.util.Arrays.asList (jalview.analysis.Rna.closingPars));
c$.closingToOpening = c$.prototype.closingToOpening =  new java.util.Hashtable ();
{
for (var i = 0; i < jalview.analysis.Rna.openingPars.length; i++) {
jalview.analysis.Rna.closingToOpening.put (jalview.analysis.Rna.closingPars[i], jalview.analysis.Rna.openingPars[i]);
}
}});
